/[MITgcm]/MITgcm/verification/testreport
ViewVC logotype

Diff of /MITgcm/verification/testreport

Parent Directory Parent Directory | Revision Log Revision Log | View Revision Graph Revision Graph | View Patch Patch

revision 1.83 by jmc, Wed Jul 5 22:39:57 2006 UTC revision 1.117 by jmc, Tue Aug 19 18:29:12 2008 UTC
# Line 15  usage() Line 15  usage()
15      echo "  (-mpi)                   compile and run using MPI"      echo "  (-mpi)                   compile and run using MPI"
16      echo "  (-ieee|-noieee)          if possible, use IEEE compiler flags"      echo "  (-ieee|-noieee)          if possible, use IEEE compiler flags"
17      echo "                             (DEF=\"-ieee\")"      echo "                             (DEF=\"-ieee\")"
18      echo "  (-optfile=|-of=)STRING   list of optfiles to use"      echo "  (-gsl)                   compile with \"-gsl\" flag"
19        echo "  (-of=|-optfile=)STRING   list of optfiles to use"
20      echo "  (-a|-addr) STRING        list of email recipients"      echo "  (-a|-addr) STRING        list of email recipients"
21      echo "                             (DEF=\"edhill@mitgcm.org\")"      echo "                             (DEF=\"\" no email is sent)"
22      echo "  (-t|-tdir) STRING        list of test dirs to use"      echo "  (-mpd|-mpackdir) DIR     location of the mpack utility"
23      echo "                             (DEF=\"\" which builds all)"      echo "                             (DEF=\"../tools/mpack-1.6\")"
24        echo "  (-t|-tdir) STRING        list of group and/or exp. dirs to test"
25        echo "                             (recognized groups: basic, tutorials)"
26        echo "                             (DEF=\"\" which test all)"
27        echo "  (-skd|-skipdir) STRING   list of exp. dirs to skip"
28        echo "                             (DEF=\"\" which test all)"
29      echo "  (-b|-bash) STRING        preferred location of a \"bash\" or"      echo "  (-b|-bash) STRING        preferred location of a \"bash\" or"
30      echo "                             Bourne-compatible \"sh\" shell"      echo "                             Bourne-compatible \"sh\" shell"
31      echo "                             (DEF=\"\" for \"bash\")"      echo "                             (DEF=\"\" for \"bash\")"
# Line 30  usage() Line 36  usage()
36      echo "                             (DEF=\"make\")"      echo "                             (DEF=\"make\")"
37      echo "  (-odir) STRING           used to build output directory name"      echo "  (-odir) STRING           used to build output directory name"
38      echo "                             (DEF=\"hostname\")"      echo "                             (DEF=\"hostname\")"
39      echo "  (-ptracers|-ptr) STRING  specify which ptracers to test"      echo "  (-ptr|-ptracers) STRING  specify which ptracers to test"
40      echo "                             (DEF=\"1 2 3 4 5\")"      echo "                             (DEF=\"1 2 3 4 5\")"
41        echo "  (-match) NUMBER          Matching Criteria (number of digits)"
42        echo "                             (DEF=\"12\")"
43      echo "  (-j) JOBS                use \"make -j JOBS\" for parallel builds"      echo "  (-j) JOBS                use \"make -j JOBS\" for parallel builds"
44      echo "  (-clean)                 *ONLY* run \"make CLEAN\""      echo "  (-clean)                 *ONLY* run \"make CLEAN\""
45      echo "  (-quick|-q)              same as \"-nogenmake -noclean -nodepend\""      echo "  (-quick|-q)              same as \"-nogenmake -noclean -nodepend\""
# Line 39  usage() Line 47  usage()
47      echo "  (-noclean|-nc)           skip the \"make clean\" stage"      echo "  (-noclean|-nc)           skip the \"make clean\" stage"
48      echo "  (-nodepend|-nd)          skip the \"make depend\" stage"      echo "  (-nodepend|-nd)          skip the \"make depend\" stage"
49      echo "  (-deldir|-dd)            on success, delete the output directory"      echo "  (-deldir|-dd)            on success, delete the output directory"
50        echo "  (-ts)                    provide timing information per timestep"
51        echo "  (-papis)                 provide MFlop/s per timestep using PAPI"
52        echo "  (-pcls)                  provide MFlop/s per timestep using PCL"
53      echo      echo
54      echo "and where STRING can be a whitespace-delimited list"      echo "and where STRING can be a whitespace-delimited list"
55      echo "such as:"      echo "such as:"
# Line 56  usage() Line 67  usage()
67  build_mpack()  build_mpack()
68  {  {
69      printf "building the mpack utility...  "      printf "building the mpack utility...  "
70      if test ! -x "$MPACKDIR/mpack" ; then      MPACK="$MPACKDIR/mpack"
71        if test ! -x $MPACK ; then
72          if test ! -d $MPACKDIR ; then          if test ! -d $MPACKDIR ; then
73              echo              echo
74              echo "Error: can't find \"$MPACKDIR\""              echo "Error: can't find \"$MPACKDIR\""
# Line 65  build_mpack() Line 77  build_mpack()
77              echo              echo
78              HAVE_MPACK=f              HAVE_MPACK=f
79          fi          fi
         printf "building mpack...  "  
80          if test "x$CC" = x ; then          if test "x$CC" = x ; then
81              export CC=cc              export CC=cc
82          fi          fi
83            printf "building mpack (using CC=$CC)...  "
84          ( cd $MPACKDIR && ./configure && $MAKE ) > tr_build_mpack.out 2>&1          ( cd $MPACKDIR && ./configure && $MAKE ) > tr_build_mpack.out 2>&1
85          RETVAL=$?          RETVAL=$?
86          if test "x$RETVAL" != x0 ; then          if test "x$RETVAL" != x0 ; then
# Line 79  build_mpack() Line 91  build_mpack()
91          else          else
92              rm -f tr_build_mpack.out              rm -f tr_build_mpack.out
93              HAVE_MPACK=t              HAVE_MPACK=t
94                echo "done"
95          fi          fi
96      else      else
97          HAVE_MPACK=t          HAVE_MPACK=t
98            echo "already exist"
99      fi      fi
     echo "OK"  
100  }  }
101    
102  testoutput_for_prop()  testoutput_var()
103  {  {
104      # testoutput_for_prop dir s1 label subdir extension      # testoutput_var dir s1 label subdir reference_output
105      #      #
106      #  compares files in $dir/$subdir/output.txt and $dir/results/output.txt      #  compares 1 variable output selected from file $dir/$subdir/$OUTPUTFILE
107      #  using search strings s1 and text label      #     with same output from reference file $dir/results/$reference_output
108        #  using search strings s1 and text label
109    
110      if [ $debug -gt 0 ]; then      if [ $debug -gt 0 ]; then
111          echo testoutput_for_prop: grep "$2" $1/$4/output.txt 1>&2          echo testoutput_var: grep "$2" $1/$4/$OUTPUTFILE 1>&2
112      fi      fi
113      if [ -r $1/$4/output.txt ]; then      if [ -r $1/$4/$OUTPUTFILE ]; then
114          grep "$2" $1/$4/output.txt | sed 's/.*=//' | cat -n > tmp1.txt          grep "$2" $1/$4/$OUTPUTFILE | sed 's/.*=//' | cat -n > tmp1.txt
115          lncntA=`wc -l tmp1.txt | awk '{print $1}' `          lncntA=`wc -l tmp1.txt | awk '{print $1}' `
116          if [ $lncntA -lt 3 ]; then          if [ $lncntA -lt 2 ]; then
117              if [ $verbose -gt 0 ]; then              if [ $verbose -gt 0 ]; then
118                  echo Not enough lines of output when searching for "$2" 1>&2                  echo Not enough lines of output when searching for "$2" 1>&2
119              fi              fi
120              return 99              return 99
121          fi          fi
122      else      else
123          echo testoutput_for_prop: output.txt from model run was not readable 1>&2          echo testoutput_var: $OUTPUTFILE from model run was not readable 1>&2
124          return 99          return 99
125      fi      fi
126      if [ $debug -gt 0 ]; then      if [ $debug -gt 0 ]; then
127          echo testoutput_for_prop: grep "$2" $1/results/output.txt$5 1>&2          echo testoutput_var: grep "$2" $1/results/$5 1>&2
128      fi      fi
129      grep "$2" $1/results/output.txt$5 | sed 's/.*=//' | cat -n > tmp2.txt      grep "$2" $1/results/$5 | sed 's/.*=//' | cat -n > tmp2.txt
130      lncntB=`wc -l tmp2.txt | awk '{print $1}' `      lncntB=`wc -l tmp2.txt | awk '{print $1}' `
131      if [ $lncntB -lt 3 ]; then      if [ $lncntB -lt 2 ]; then
132          if [ $verbose -gt 0 ]; then          if [ $verbose -gt 0 ]; then
133              echo Not enough lines of output when searching for "$2" 1>&2              echo Not enough lines of output when searching for "$2" 1>&2
134          fi          fi
# Line 128  testoutput_for_prop() Line 142  testoutput_for_prop()
142      fi      fi
143      has_nan=`cat tmp1.txt | grep -i nan | wc -l`      has_nan=`cat tmp1.txt | grep -i nan | wc -l`
144      if [ $has_nan -gt 0  ] ; then      if [ $has_nan -gt 0  ] ; then
145          echo testoutput_for_prop: output.txt contains $has_nan NaN values  1>&2          echo testoutput_var: $OUTPUTFILE contains $has_nan NaN values  1>&2
146          return 99          return 99
147      fi      fi
148      has_inf=`cat tmp1.txt | grep -i inf | wc -l`      has_inf=`cat tmp1.txt | grep -i inf | wc -l`
149      if [ $has_inf -gt 0  ] ; then      if [ $has_inf -gt 0  ] ; then
150          echo testoutput_for_prop: output.txt contains $has_inf Inf values  1>&2          echo testoutput_var: $OUTPUTFILE contains $has_inf Inf values  1>&2
151          return 99          return 99
152      fi      fi
153      if [ $debug -gt 0 ]; then      if [ $debug -gt 0 ]; then
154          echo testoutput_for_prop: join tmp1.txt tmp2.txt 1>&2          echo testoutput_var: join tmp1.txt tmp2.txt 1>&2
155      fi      fi
156      join tmp1.txt tmp2.txt | awk '{print $1 " " $2 " " $3}' > tmp3.txt      join tmp1.txt tmp2.txt | awk '{print $1 " " $2 " " $3}' > tmp3.txt
157      if [ $debug -gt 0 ]; then      if [ $debug -gt 0 ]; then
158          echo testoutput_for_prop: compare_lines 1>&2          echo testoutput_var: compare_lines 1>&2
159      fi      fi
160      if [ $verbose -gt 1 ]; then      if [ $verbose -gt 1 ]; then
161          cat tmp3.txt 1>&2          cat tmp3.txt 1>&2
# Line 149  testoutput_for_prop() Line 163  testoutput_for_prop()
163      echo "-1" >> tmp3.txt      echo "-1" >> tmp3.txt
164      # On the SGI O3K (*not* the O2K), "cat -n" inserts a ":" after the line number      # On the SGI O3K (*not* the O2K), "cat -n" inserts a ":" after the line number
165      cat tmp3.txt | sed -e 's|:||g' > tmp4.txt      cat tmp3.txt | sed -e 's|:||g' > tmp4.txt
166      digits_of_similarity=`./tmp_cmpnum < tmp4.txt`      digits_of_similarity=`./tr_cmpnum < tmp4.txt`
167      if [ $digits_of_similarity -eq 99 ]; then      if [ $digits_of_similarity -eq 99 ]; then
168          if [ $verbose -gt 0 ]; then          if [ $verbose -gt 0 ]; then
169              echo testoutput_for_prop: No comparison was available for \"$2\" 1>&2              echo testoutput_var: No comparison was available for \"$3\" 1>&2
170          fi          fi
171          digits_of_similarity=99          digits_of_similarity=99
172      else      else
173          if [ $verbose -gt 0 ]; then          if [ $verbose -gt 0 ]; then
174              echo There were $digits_of_similarity decimal places of similarity for \"$2\" 1>&2              echo There were $digits_of_similarity decimal places of similarity for \"$3\" 1>&2
175          fi          fi
176      fi      fi
177      rm -f tmp1.txt tmp2.txt tmp3.txt tmp4.txt      rm -f tmp1.txt tmp2.txt tmp3.txt tmp4.txt
# Line 165  testoutput_for_prop() Line 179  testoutput_for_prop()
179      return $digits_of_similarity      return $digits_of_similarity
180  }  }
181    
182  dashnum()  testoutput_run()
183  {  {
184      # dashnum n1 n2 n3 ...      # testoutput_run directory subdir reference_output
185      #      #
186      #  print numbers using %3i format or "--" if number = 99      #  test output from 1 run in "directory"
187    # --> same processing for adjoint & forward test
188      for num in $@ ; do          # default list of output variables to be checked:
189          if [ $num = 99 ]; then          #  1rst : main variable used to decide if it pass or FAIL
190              printf ' --'          #  others : number of matching digits to be printed in summary.txt
191          else          listChk=$DEF_CHECK_LIST
192              printf '%3i' $num          #  load experiment-specific list from file "tr_checklist" (if it exist)
193          fi          if test -r $1/$2/tr_checklist ; then listChk=`cat $1/$2/tr_checklist` ; fi
194      done          sVar=`echo $listChk | awk '{print $1}'`
195  }          # remove 1rst var and expand the list: + => min max mean s.d
196            listVar=`echo $listChk | sed 's/ [a-zA-Z0-9]*+/&mn &mx &av &sd/g' \
197  testoutput_ad()                                 | sed 's/+//g' | sed "s/^$sVar//"`
198  {          if [ $debug -gt 0 ]; then echo "testoutput_run: listVar(I)='$listVar'" 1>&2 ; fi
199      grep $3 $1/results_ad/output_adm.txt | awk '{print NR " " $5}' > t05.txt          # check for ptracer output in reference_output file :
200      grep $3 $1/$2/output_adm.txt | awk '{print NR " " $5}' > t15.txt          outpref=$1/results/$3
201      grep $3 $1/results_ad/output_adm.txt | awk '{print NR " " $6}' > t06.txt          ptr_mon="trcstat_ptracerXX_min trcstat_ptracerXX_max"
202      grep $3 $1/$2/output_adm.txt | awk '{print NR " " $6}' > t16.txt          ptr_mon="$ptr_mon trcstat_ptracerXX_mean trcstat_ptracerXX_sd"
     join t05.txt t15.txt > t5.txt  
     join t06.txt t16.txt > t6.txt  
     echo "-1" >> t5.txt  
     echo "-1" >> t6.txt  
     digits_5=`./tmp_cmpnum < t5.txt`  
     digits_6=`./tmp_cmpnum < t6.txt`  
     dashnum $digits_5 $digits_6  
     rm -f t[01][56].txt t[56].txt  
 }  
   
 check_for_add_mon_output()  
 {  
     # Check for additional types of monitor output  
     if test "x$1" = x ; then  
         return  
     fi  
   
     for ii in $PTRACERS_NUM ; do  
         eval "HAVE_PTR0"$ii"=f"  
     done  
   
     ptr_add="trcstat_ptracerXX_min trcstat_ptracerXX_max"  
     ptr_add="$ptr_add trcstat_ptracerXX_mean trcstat_ptracerXX_sd"  
     for ii in $PTRACERS_NUM ; do  
         for jj in $ptr_add ; do  
             name=`eval "echo $jj | sed -e 's|XX|0"$ii"|g'"`  
             tst=`grep $name $1 | wc -l | awk '{print $1}'`  
             if test ! "x$tst" = x0 ; then  
                 eval "HAVE_PTR0"$ii"=t"  
             fi  
         done  
         #  eval 'echo "HAVE_PTR0'$ii' = $HAVE_PTR0'$ii'"'  
     done  
 }  
   
 testoutput()  
 {  
     # testoutput directory subdir extension  
     #  
     #  test output in "directory"  
     if test "x$ADM" = x ; then  
         if [ $debug -gt 0 ]; then  
             echo testoutput: testoutput_for_prop $1 cg2d_init_res 1>&2  
         fi  
         testoutput_for_prop $1 "cg2d_init_res" "cg2d init. residual" $2 $3; cg2dres=$?  
         if [ $debug -gt 0 ]; then  
             echo testoutput: cg2dres=$cg2dres 1>&2  
         fi  
         testoutput_for_prop $1 "dynstat_theta_min" "theta minimum" $2 $3; tmin=$?  
         testoutput_for_prop $1 "dynstat_theta_max" "theta maximum" $2 $3; tmax=$?  
         testoutput_for_prop $1 "dynstat_theta_mean" "theta mean" $2 $3; tmean=$?  
         testoutput_for_prop $1 "dynstat_theta_sd" "theta s.d." $2 $3; tsd=$?  
         testoutput_for_prop $1 "dynstat_salt_min" "salt minimum" $2 $3; smin=$?  
         testoutput_for_prop $1 "dynstat_salt_max" "salt maximum" $2 $3; smax=$?  
         testoutput_for_prop $1 "dynstat_salt_mean" "salt mean" $2 $3; smean=$?  
         testoutput_for_prop $1 "dynstat_salt_sd" "salt s.d." $2 $3; ssd=$?  
         testoutput_for_prop $1 "dynstat_uvel_min" "U minimum" $2 $3; umin=$?  
         testoutput_for_prop $1 "dynstat_uvel_max" "U maximum" $2 $3; umax=$?  
         testoutput_for_prop $1 "dynstat_uvel_mean" "U mean" $2 $3; umean=$?  
         testoutput_for_prop $1 "dynstat_uvel_sd" "U s.d." $2 $3; usd=$?  
         testoutput_for_prop $1 "dynstat_vvel_min" "V minimum" $2 $3; vmin=$?  
         testoutput_for_prop $1 "dynstat_vvel_max" "V maximum" $2 $3; vmax=$?  
         testoutput_for_prop $1 "dynstat_vvel_mean" "V mean" $2 $3; vmean=$?  
         testoutput_for_prop $1 "dynstat_vvel_sd" "V s.d." $2 $3; vsd=$?  
   
         #  This is for PTRACERS  
203          for ii in $PTRACERS_NUM ; do          for ii in $PTRACERS_NUM ; do
204              eval `echo "p0"$ii"_min=99"`              ptrfound=0
205              eval `echo "p0"$ii"_max=99"`              for jj in $ptr_mon ; do
206              eval `echo "p0"$ii"_mean=99"`                  name=`eval "echo $jj | sed -e 's|XX|0"$ii"|g'"`
207              eval `echo "p0"$ii"_sd=99"`                  tst=`grep $name $outpref | wc -l | awk '{print $1}'`
208              tst=`eval 'echo "$HAVE_PTR0'$ii'"'`                  if test ! "x$tst" = x0 ; then ptrfound=1 ; fi
209              #echo 'tst = '$tst              done
210              if test "x$tst" = xt ; then              if test $ptrfound = '1' ; then
211                  a="trcstat_ptracer0"                  eval "HAVE_PTR0"$ii"=t"
212                  testoutput_for_prop $1 "$a"$ii"_min"  "p0"$ii"_min"  $2 $3              else
213                  RETVAL=$? ; eval `echo "p0"$ii"_min="$RETVAL`                  eval "HAVE_PTR0"$ii"=f"
214                  testoutput_for_prop $1 "$a"$ii"_max"  "p0"$ii"_max"  $2 $3                if test "x$ADM" = x ; then
215                  RETVAL=$? ; eval `echo "p0"$ii"_max="$RETVAL`                # remove this ptr from the list of output variable to check
216                  testoutput_for_prop $1 "$a"$ii"_mean" "p0"$ii"_mean" $2 $3                # echo "-- ptr test=" $tst "number of var=" `echo $listVar | awk '{print NF}'` 1>&2
217                  RETVAL=$? ; eval `echo "p0"$ii"_mean="$RETVAL`                  listVar=`echo "$listVar" | sed "s/ pt$ii..//g"`
218                  testoutput_for_prop $1 "$a"$ii"_sd"   "p0"$ii"_sd"   $2 $3                fi
                 RETVAL=$? ; eval `echo "p0"$ii"_sd="$RETVAL`  
219              fi              fi
220            #   eval 'echo "HAVE_PTR0'$ii' = $HAVE_PTR0'$ii'"' 1>&2
221          done          done
222            tst=`echo $sVar $listVar | awk '{ for(i=2;i<=NF;i++){if($i==$1)t+=1}; print t }'`
223          allargs="$cg2dres $tmin $tmax $tmean $tsd $smin $smax $smean $ssd"          if test $tst != 1 ; then
224          allargs="$allargs $umin $umax $umean $usd $vmin $vmax $vmean $vsd"            if test $tst = 0 ; then echo "==> WARNING: selected var >$sVar< not found" 1>&2
225          allargs="$allargs $p01_min $p01_max $p01_mean $p01_sd"                   else echo "==> WARNING: found selected var >$sVar< $tst times" 1>&2 ; fi
226          allargs="$allargs $p02_min $p02_max $p02_mean $p02_sd"            echo "==> WARNING: in checked list:" $listVar 1>&2
227          allargs="$allargs $p03_min $p03_max $p03_mean $p03_sd"          #- put it back once:
228          allargs="$allargs $p04_min $p04_max $p04_mean $p04_sd"            listVar=" $sVar "`echo "$listVar " | sed "s/ $sVar / /g"`
229          allargs="$allargs $p05_min $p05_max $p05_mean $p05_sd"          fi
230            if [ $debug -gt 0 ]; then echo "testoutput_run: listVar(M)='$listVar'" 1>&2 ; fi
231          eval "dashnum $allargs"          echo "listVar='$listVar'" > $CDIR"/summary.txt"
232            allargs=""
233      else          for xx in $listVar
234          testoutput_ad $1 $2 "precision_grdchk_result"          do
235      fi            case $xx in
236               'PS')  if [ $debug -gt 0 ]
237                      then echo testoutput_run: testoutput_var $1 cg2d_init_res 1>&2 ; fi
238                      testoutput_var $1 "cg2d_init_res" "Press. Solver (cg2d)" $2 $3; yy=$?
239                      if [ $debug -gt 0 ] ; then echo testoutput_run: cg2dres=$yy 1>&2 ; fi ;;
240              'Cost') testoutput_var $1 "ADM  precision_derivative_cost" "ADM Cost" $2 $3; yy=$? ;;
241              'Grad') testoutput_var $1 "ADM  precision_derivative_grad" "ADM Grad" $2 $3; yy=$? ;;
242               'Tmn') testoutput_var $1 "dynstat_theta_min"  "Theta minimum"  $2 $3; yy=$? ;;
243               'Tmx') testoutput_var $1 "dynstat_theta_max"  "Theta maximum"  $2 $3; yy=$? ;;
244               'Tav') testoutput_var $1 "dynstat_theta_mean" "Theta mean"     $2 $3; yy=$? ;;
245               'Tsd') testoutput_var $1 "dynstat_theta_sd"   "Theta Std.Dev"  $2 $3; yy=$? ;;
246               'Smn') testoutput_var $1 "dynstat_salt_min"  "Salt minimum"    $2 $3; yy=$? ;;
247               'Smx') testoutput_var $1 "dynstat_salt_max"  "Salt maximum"    $2 $3; yy=$? ;;
248               'Sav') testoutput_var $1 "dynstat_salt_mean" "Salt mean"       $2 $3; yy=$? ;;
249               'Ssd') testoutput_var $1 "dynstat_salt_sd"   "Salt Std.Dev"    $2 $3; yy=$? ;;
250               'Umn') testoutput_var $1 "dynstat_uvel_min"  "U minimum"       $2 $3; yy=$? ;;
251               'Umx') testoutput_var $1 "dynstat_uvel_max"  "U maximum"       $2 $3; yy=$? ;;
252               'Uav') testoutput_var $1 "dynstat_uvel_mean" "U mean"          $2 $3; yy=$? ;;
253               'Usd') testoutput_var $1 "dynstat_uvel_sd"   "U Std.Dev"       $2 $3; yy=$? ;;
254               'Vmn') testoutput_var $1 "dynstat_vvel_min"  "V minimum"       $2 $3; yy=$? ;;
255               'Vmx') testoutput_var $1 "dynstat_vvel_max"  "V maximum"       $2 $3; yy=$? ;;
256               'Vav') testoutput_var $1 "dynstat_vvel_mean" "V mean"          $2 $3; yy=$? ;;
257               'Vsd') testoutput_var $1 "dynstat_vvel_sd"   "V Std.Dev"       $2 $3; yy=$? ;;
258            'pt1mn'|'pt2mn'|'pt3mn'|'pt4mn'|'pt5mn') ii=`echo $xx | sed 's/pt//' | sed 's/..$//'`
259               testoutput_var $1 "trcstat_ptracer0"$ii"_min"  "p0"$ii"_min"   $2 $3; yy=$? ;;
260            'pt1mx'|'pt2mx'|'pt3mx'|'pt4mx'|'pt5mx') ii=`echo $xx | sed 's/pt//' | sed 's/..$//'`
261               testoutput_var $1 "trcstat_ptracer0"$ii"_max"  "p0"$ii"_max"   $2 $3; yy=$? ;;
262            'pt1av'|'pt2av'|'pt3av'|'pt4av'|'pt5av') ii=`echo $xx | sed 's/pt//' | sed 's/..$//'`
263               testoutput_var $1 "trcstat_ptracer0"$ii"_mean" "p0"$ii"_mean" $2 $3; yy=$? ;;
264            'pt1sd'|'pt2sd'|'pt3sd'|'pt4sd'|'pt5sd') ii=`echo $xx | sed 's/pt//' | sed 's/..$//'`
265               testoutput_var $1 "trcstat_ptracer0"$ii"_sd"   "p0"$ii"_StDv"  $2 $3; yy=$? ;;
266             'Qntmn') testoutput_var $1 "extforcing_qnet_min" "Qnet minimum"  $2 $3; yy=$? ;;
267             'Qntmx') testoutput_var $1 "extforcing_qnet_max" "Qnet maximum"  $2 $3; yy=$? ;;
268             'Qntav') testoutput_var $1 "extforcing_qnet_mean" "Qnet mean"    $2 $3; yy=$? ;;
269             'Qntsd') testoutput_var $1 "extforcing_qnet_sd"  "Qnet Std.Dev"  $2 $3; yy=$? ;;
270             'aSImn') testoutput_var $1 "seaice_area_min"   "SIce Area min"   $2 $3; yy=$? ;;
271             'aSImx') testoutput_var $1 "seaice_area_max"   "SIce Area max"   $2 $3; yy=$? ;;
272             'aSIav') testoutput_var $1 "seaice_area_mean"  "SIce Area mean"  $2 $3; yy=$? ;;
273             'aSIsd') testoutput_var $1 "seaice_area_sd"    "SIce Area StDv"  $2 $3; yy=$? ;;
274             'hSImn') testoutput_var $1 "seaice_heff_min"   "SIce Heff min"   $2 $3; yy=$? ;;
275             'hSImx') testoutput_var $1 "seaice_heff_max"   "SIce Hell max"   $2 $3; yy=$? ;;
276             'hSIav') testoutput_var $1 "seaice_heff_mean"  "SIce Hell mean"  $2 $3; yy=$? ;;
277             'hSIsd') testoutput_var $1 "seaice_heff_sd"    "SIce Hell StDv"  $2 $3; yy=$? ;;
278            'AthSiG') testoutput_var $1 "thSI_Ice_Area_G" "thSIc Area Global" $2 $3; yy=$? ;;
279            'AthSiS') testoutput_var $1 "thSI_Ice_Area_S" "thSIc Area South"  $2 $3; yy=$? ;;
280            'AthSiN') testoutput_var $1 "thSI_Ice_Area_N" "thSIc Area North"  $2 $3; yy=$? ;;
281            'HthSiG') testoutput_var $1 "thSI_IceH_ave_G" "thSIc H Global"    $2 $3; yy=$? ;;
282            'HthSiS') testoutput_var $1 "thSI_IceH_ave_S" "thSIc H South"     $2 $3; yy=$? ;;
283            'HthSiN') testoutput_var $1 "thSI_IceH_ave_N" "thSIc H North"     $2 $3; yy=$? ;;
284                  *) yy=99; echo "WARNING: asking for var=$xx : not recognized !" 1>&2 ;;
285              esac
286              if test $xx = $sVar
287              then allargs="$allargs > $yy <"
288              else allargs="$allargs $yy"
289              fi
290            done
291    
292            nbVar=`echo $listVar | awk '{print NF}'`
293            if [ $nbVar -lt $LEN_CHECK_LIST ] ; then
294            #-- fill line (up to standard length) with dot:
295              adNul=`expr $LEN_CHECK_LIST - $nbVar | awk '{for(i=1;i<=$1;i++){print "."}}'`
296              echo $allargs $adNul
297            else
298              echo $allargs
299            fi
300    # <-- same processing for adjoint & forward test
301  }  }
302    
303  genmakemodel()  genmakemodel()
# Line 312  genmakemodel() Line 325  genmakemodel()
325              if test "x$IEEE" != x ; then              if test "x$IEEE" != x ; then
326                  command="$command -ieee"                  command="$command -ieee"
327              fi              fi
328                if test "x$GSL" = xt ; then
329                    command="$command -gsl"
330                fi
331              if test "x$MPI" = xt ; then              if test "x$MPI" = xt ; then
332                  command="$command -mpi"                  command="$command -mpi"
333              fi              fi
334                if test "x$TS" = xt ; then
335                    command="$command -ts"
336                fi
337                if test "x$PAPIS" = xt ; then
338                    command="$command -papis"
339                else
340                if test "x$PCLS" = xt ; then
341                    command="$command -pcls"
342                fi
343                fi
344              printf 'genmake ... ' 1>&2              printf 'genmake ... ' 1>&2
345              $command > make.log 2>&1              $command > make.log 2>&1
346              RETVAL=$?              RETVAL=$?
# Line 340  makeclean() Line 366  makeclean()
366      else      else
367          (          (
368              cd $1;              cd $1;
369              #if test -e output.txt ; then rm -f output.txt ; fi              #if test -e $OUTPUTFILE ; then rm -f $OUTPUTFILE ; fi
370              if test -r Makefile ; then              if test -r Makefile ; then
371                  printf 'clean build-dir: make Clean ... ' 2>&1                  printf 'clean build-dir: make Clean ... ' 2>&1
372                  $MAKE Clean >> make.log 2>&1                  $MAKE Clean >> make.log 2>&1
# Line 374  run_clean() Line 400  run_clean()
400              find . -type l -exec rm {} \;              find . -type l -exec rm {} \;
401              rm -f $EXECUTABLE *.txt STD* *diagnostics.log datetime              rm -f $EXECUTABLE *.txt STD* *diagnostics.log datetime
402              rm -rf mnc_test_*              rm -rf mnc_test_*
403                rm -f *_MIT_CE_000.opt0000 costfunction*0000
404              echo successful 1>&2              echo successful 1>&2
405              exit 0              exit 0
406          )          )
# Line 444  symlink_mpifiles() Line 471  symlink_mpifiles()
471      CODE_DIR=$dir/$code_dir      CODE_DIR=$dir/$code_dir
472            
473      # These are files that should replace their counter-part when using -mpi      # These are files that should replace their counter-part when using -mpi
474      MPI_FILES=`(cd $CODE_DIR; find . -name "*_mpi")`      MPI_FILES=`(cd $CODE_DIR; find . -name "*_mpi" -print)`
475    
476      #  Is this an MPI run?      #  Is this an MPI run?
477      if test "x$MPI" = xt ; then      if test "x$MPI" = xt ; then
# Line 502  linkdata() Line 529  linkdata()
529                      if test -h eedata ; then rm -f eedata ; fi                      if test -h eedata ; then rm -f eedata ; fi
530                  fi                  fi
531              fi              fi
532                prevDir='NONE'
533              for ldir in $* ; do              for ldir in $* ; do
534                  if test -d "../"$ldir ; then                  if test -d "../"$ldir -a $ldir != $prevDir ; then
535                      printf 'ldir='${ldir} 1>&2                      printf 'ldir='${ldir} 1>&2
536                      files=`( cd "../"$ldir ; ls -1 | grep -v CVS )`                      files=`( cd "../"$ldir ; ls -1 | grep -v CVS )`
537                      for i in $files ; do                      for i in $files ; do
# Line 519  linkdata() Line 547  linkdata()
547                      fi                      fi
548                      printf ' ; ' 1>&2                      printf ' ; ' 1>&2
549                  fi                  fi
550                    prevDir=$ldir
551              done              done
552          )          )
553      fi      fi
# Line 535  runmodel() Line 564  runmodel()
564          printf 'runmodel in %s ...' $1 1>&2          printf 'runmodel in %s ...' $1 1>&2
565          # make output.txt          # make output.txt
566          echo          echo
567          rm -f run.log          if test -L $EXECUTABLE -a -x "../"$builddir"/"$EXECUTABLE ; then
568                diff -q $EXECUTABLE "../"$builddir"/"$EXECUTABLE > /dev/null 2>&1
569                outD=$? ; if test $outD != 0 ; then rm -f $EXECUTABLE ; rm -f run.log ; fi
570            fi
571          if test ! -x $EXECUTABLE -a -x "../"$builddir"/"$EXECUTABLE ; then          if test ! -x $EXECUTABLE -a -x "../"$builddir"/"$EXECUTABLE ; then
572              echo " link" $EXECUTABLE "from dir ../"$builddir > run.log              echo " link" $EXECUTABLE "from dir ../"$builddir > run.log_00
573              ln -sf "../"$builddir"/"$EXECUTABLE .              ln -sf "../"$builddir"/"$EXECUTABLE .
         else  
             touch run.log  
574          fi          fi
575          if test ! -x $EXECUTABLE ; then          if test ! -x $EXECUTABLE ; then
576                    rm -f run.log ; touch run.log
577                    if test -f run.log_00 ; then cat run.log_00 >> run.log ; fi
578                  echo " no executable:" $EXECUTABLE >> run.log                  echo " no executable:" $EXECUTABLE >> run.log
579                  RETVAL=8                  RETVAL=8
580                    ENDVAL=-1
581          else          else
582              if test $OUTPUTFILE -ot $EXECUTABLE ; then              if test ! -f $OUTPUTFILE -o $OUTPUTFILE -ot $EXECUTABLE ; then
583                  # output do not exist or is older than executable:
584                    rm -f run.log ; touch run.log
585                    if test -f run.log_00 ; then cat run.log_00 >> run.log ; fi
586                  ( eval $COMMAND ) >> run.log 2>&1                  ( eval $COMMAND ) >> run.log 2>&1
587                  RETVAL=$?                  RETVAL=$?
588              else              else
                 echo " $OUTPUTFILE is up to date " >> run.log 2>&1  
589                  RETVAL=0                  RETVAL=0
590                    if test -f run.log ; then
591                        if test -f run.log_00 ; then cat run.log_00 >> run.log ; fi
592                        echo "---------->> $OUTPUTFILE is up to date " >> run.log 2>&1
593                    else
594                        touch run.log
595                        if test -f run.log_00 ; then cat run.log_00 >> run.log ; fi
596                        echo "---------->> $OUTPUTFILE is up to date " >> run.log 2>&1
597                        echo " no previous run.log: assume NORMAL END" >> run.log 2>&1
598                    fi
599              fi              fi
600                ENDVAL=`cat run.log | grep -v 'ABNORMAL END' | grep -c 'NORMAL END'`
601          fi          fi
602          # echo "COMMAND='$COMMAND'"          rm -f run.log_00
603          # echo "pwd='"`pwd`"'"          #if test "x$RETVAL" = x0 ; then
604          if test "x$RETVAL" = x0 ; then          if [ $RETVAL -eq 0 -a $ENDVAL -gt 0 ] ; then
605              tail run.log              tail run.log
606              echo successful 1>&2              echo successful 1>&2
607              # === Reduce the size of the testing emails!              # === Reduce the size of the testing emails!
608              # if test "x$ADM" = x ; then              #cp $OUTPUTFILE $CDIR"/"$OUTPUTFILE
             #   cp output.txt $CDIR"/output.txt"  
             # else  
             #   cp output_adm.txt $CDIR"/output_adm.txt"  
             # fi  
609              if test -s STDERR.0000 ; then cp STDERR.0000 $CDIR"/STDERR.0000" ; fi              if test -s STDERR.0000 ; then cp STDERR.0000 $CDIR"/STDERR.0000" ; fi
610              return 0              return 0
611          else          else
612              tail run.log              tail run.log
613              echo failed 1>&2              echo failed '(run:' $RETVAL ' end:' $ENDVAL ')' 1>&2
614              cp run.log $CDIR"/run.log"              cp run.log $CDIR"/run.log"
615              if test -s STDERR.0000 ; then cp STDERR.0000 $CDIR"/STDERR.0000" ; fi              if test -s STDERR.0000 ; then cp STDERR.0000 $CDIR"/STDERR.0000" ; fi
616              return 1              return 1
# Line 581  createcodelet() Line 622  createcodelet()
622  {  {
623      # create codelet for comparing model output      # create codelet for comparing model output
624    
625      printf "creating the comparison code...  "      printf "creating the comparison code (using CC=$CC)...  "
626      cat > tmp_cmpnum.c <<EOF      cat > tr_cmpnum.c <<EOF
627  #include <stdio.h>  #include <stdio.h>
628  #include <math.h>  #include <math.h>
629  int main( int argc, char** argv )  {  int main( int argc, char** argv )  {
630    int linnum,best,lncnt;    int linnum,cmplin,best,lncnt;
631    double a,b,abave,relerr;    double a,b,abave,relerr;
632    best = -22;    best = -22;
633    lncnt = 0;    lncnt = 0;
634    while( 1 & (lncnt+=1) < 999 )  {    while( 1 & ( (lncnt+=1) < 999 ) )  {
635      scanf("%d", &linnum);      scanf("%d", &linnum);
636      if (linnum == -1)  break;      if (linnum == -1)  break;
637      scanf("%lf", &a);  scanf("%lf", &b);      scanf("%lf", &a);  scanf("%lf", &b);
638      abave = 0.5*(fabs(a)+fabs(b));      abave = 0.5*(fabs(a)+fabs(b));
639      if (abave > 0.0) {      if ( abave == abave ) {
640        relerr=fabs(a-b)/abave;        if (abave > 0.0) {
641        if (relerr > 0.0) { linnum = (int)rint(log10(relerr)); }          relerr=fabs(a-b)/abave;
642        else { linnum = -16 ; }          if (relerr > 0.0) { cmplin = (int)rint(log10(relerr)); }
643        best = (best > linnum) ? best : linnum;          else { cmplin = -16 ; }
644      }          best = (best > cmplin) ? best : cmplin; }
645          else { cmplin = -22 ; }
646       /* printf("%d ; %lf ; %lf\n",cmplin,a,b); */
647          }
648       else {
649       /* printf("%lf ; %lf ; %lf\n",abave,a,b); */
650          break; }
651    }    }
652    if (lncnt == 999) best=-29;    if (lncnt == 999) best=-29;
653      if (linnum != -1) best=-99;
654    printf("%d\n", -best);    printf("%d\n", -best);
655    return 0;    return 0;
656  }  }
657  EOF  EOF
658      $CC -o tmp_cmpnum tmp_cmpnum.c -lm      $CC -o tr_cmpnum tr_cmpnum.c -lm
659    
660      if [ -x ./tmp_cmpnum ]; then      if [ -x ./tr_cmpnum ]; then
661          echo "OK"          echo "OK"
662          return 0          return 0
663      else      else
# Line 627  formatresults() Line 675  formatresults()
675      nm=$1      nm=$1
676      printf '%s %s %s %s' $2 $3 $4 $5      printf '%s %s %s %s' $2 $3 $4 $5
677      shift; shift; shift; shift; shift;      shift; shift; shift; shift; shift;
678      printf '%3s' $@      listPrt=$@
679        listRes=`echo $listPrt | sed 's/>//' | sed 's/<//'`
680        xx=`echo $listPrt | sed 's/.*>//' | sed 's/<.*//' | awk '{print $1}'`
681        printf '%3s' $listPrt
682    #   line below does not work on hp-ux_ia64 : do those substitutions later on
683    #   printf '%3s' $listPrt | sed 's/ 99/ --/g' | sed 's/  > />/' | sed 's/  < /</'
684            
685      if [ $1 = '--' ]; then      if [ $xx = '..' ]; then
686            printf ' N/O '
687        elif [ $xx = '--' ]; then
688            printf ' N/O '
689        elif [ $xx = 99 ]; then
690          printf ' N/O '          printf ' N/O '
691      else      else
692          if [ $1 -gt 12 ]; then          if [ $xx -ge $MATCH_CRIT ]; then
693              printf ' pass'              printf ' pass'
694          else          else
695              printf ' FAIL'              printf ' FAIL'
# Line 643  formatresults() Line 700  formatresults()
700            
701  }  }
702    
 show_help()  
 {  
     cat - << EOF  
 $0 [-help] [-quick] [-verbose] dir1 [dir2] [...]  
   
  -help|-h      Show this help message  
  -quiet     Reduce the amount of output  
  -verbose   Produce copious amounts of output  
  -debug     Produce even more output which will mean nothing to most  
  -force     Do "make CLEAN" before compiling. This forces a complete rebuild.  
  -clean     Do "make CLEAN" after compiling and testing.  
  -cleanup   Aggresively removes all model output, executables and object files  
             and then exits. Use with care.  
   
 Normal usage:  
  $0 *       Configure, compile, run and analyze in all experiment directories  
 EOF  
 }  
   
703  scandirs()  scandirs()
704  {  {
705      if [ $# -eq 1 ]; then      if [ $# -eq 1 ]; then
706          for arg in * ; do          for arg in * ; do
707              test -d $arg/$1 && echo $arg              test -f $arg/$1 && echo $arg
708          done          done
709      else      else
710          echo $*          echo $*
# Line 681  scandirs() Line 719  scandirs()
719  debug=0  debug=0
720  verbose=1  verbose=1
721  clean=0  clean=0
 expts=''  
 # ieee=1  
722    
723  IEEE=true  IEEE=true
724  if test "x$MITGCM_IEEE" != x ; then  if test "x$MITGCM_IEEE" != x ; then
725      IEEE=$MITGCM_IEEE      IEEE=$MITGCM_IEEE
726  fi  fi
727    GSL=f
728    
729  CLEANUP=f  CLEANUP=f
730  QUICK=f  QUICK=f
# Line 701  BASH= Line 737  BASH=
737  OPTFILE=NONE  OPTFILE=NONE
738  ADDRESSES=  ADDRESSES=
739  TESTDIRS=  TESTDIRS=
740    SKIPDIRS=
741  MPACKDIR="../tools/mpack-1.6"  MPACKDIR="../tools/mpack-1.6"
742  HAVE_MPACK=  HAVE_MPACK=
743  MPACK="$MPACKDIR/mpack"  MPACK=
744  COMMAND=  COMMAND=
745  if test "x$MAKE" = x ; then  if test "x$MAKE" = x ; then
746      MAKE=make      MAKE=make
# Line 719  DELDIR= Line 756  DELDIR=
756    
757  ADM=  ADM=
758    
759  # Additional monitor types  # list of pTracers to check for monitor output
760  PTRACERS_NUM="1 2 3 4 5"  PTRACERS_NUM="1 2 3 4 5"
761    
762    MATCH_CRIT=13
763    
764  printf "parsing options...  "  printf "parsing options...  "
765    
766  ac_prev=  ac_prev=
# Line 750  for ac_option ; do Line 789  for ac_option ; do
789              ac_prev=ADDRESSES ;;              ac_prev=ADDRESSES ;;
790          -addr=* | --addr=*)          -addr=* | --addr=*)
791              ADDRESSES=$ac_optarg ;;              ADDRESSES=$ac_optarg ;;
792            -mpackdir | --mpackdir | -mpd | --mpd)
793                ac_prev=MPACKDIR ;;
794            -mpackdir=* | --mpackdir=* | -mpd=* | --mpd=*)
795                MPACKDIR=$ac_optarg ;;
796    
797          -tdir | --tdir | -t | --t)          -tdir | --tdir | -t | --t)
798              ac_prev=TESTDIRS ;;              ac_prev=TESTDIRS ;;
799          -tdir=* | --tdir=*)          -tdir=* | --tdir=*)
800              TESTDIRS=$ac_optarg ;;              TESTDIRS=$ac_optarg ;;
801    
802            -skipdir | --skipdir | -skd | --skd)
803                ac_prev=SKIPDIRS ;;
804            -skipdir=* | --skipdir=*)
805                SKIPDIRS=$ac_optarg ;;
806    
807          -bash | --bash | -b | --b)          -bash | --bash | -b | --b)
808              ac_prev=BASH ;;              ac_prev=BASH ;;
809          -bash=* | --bash=*)          -bash=* | --bash=*)
# Line 781  for ac_option ; do Line 829  for ac_option ; do
829          -ptracers=* | --ptracers=* | -ptr=* | --ptr=*)          -ptracers=* | --ptracers=* | -ptr=* | --ptr=*)
830              PTRACERS_NUM=$ac_optarg ;;              PTRACERS_NUM=$ac_optarg ;;
831    
832            -match | --match ) ac_prev=MATCH_CRIT ;;
833            -match=* | --match=* ) MATCH_CRIT=$ac_optarg ;;
834    
835          -j) ac_prev=JOBS ;;          -j) ac_prev=JOBS ;;
836          -j=*) JOBS=$ac_optarg ;;          -j=*) JOBS=$ac_optarg ;;
837    
# Line 807  for ac_option ; do Line 858  for ac_option ; do
858    
859          -ieee) IEEE=true ;;          -ieee) IEEE=true ;;
860          -noieee) IEEE= ;;          -noieee) IEEE= ;;
861            -gsl) GSL=t ;;
862    
863          -verbose) verbose=2 ;;          -verbose) verbose=2 ;;
864          -debug) debug=1 ;;          -debug) debug=1 ;;
# Line 814  for ac_option ; do Line 866  for ac_option ; do
866    
867          -deldir | -dd) DELDIR=t ;;          -deldir | -dd) DELDIR=t ;;
868    
869            -ts) TS=t;;
870    
871            -papis) PAPIS=t;;
872    
873            -pcls) PCL=t;;
874    
875          -*)          -*)
876              echo "Error: unrecognized option: "$ac_option              echo "Error: unrecognized option: "$ac_option
877              usage              usage
# Line 834  if test "x$QUICK" = xt ; then Line 892  if test "x$QUICK" = xt ; then
892      NODEPEND=t      NODEPEND=t
893  fi  fi
894    
895  if test "x$TESTDIRS" = x ; then  #- setting for forward or ADM testing
     if test "x$ADM" = xt ; then  
         TESTDIRS=`scandirs results_ad`  
     else  
         TESTDIRS=`scandirs results`  
     fi  
 fi  
   
 if test "x$OPTFILE" = xNONE -a "x$MITGCM_OF" != x ; then  
     OPTFILE=$MITGCM_OF  
 fi  
   
896  if test "x$ADM" = xt ; then  if test "x$ADM" = xt ; then
897        code_dir=code_ad
898        inputdir=input_ad
899        ref_outp="output_adm.txt"
900      EXECUTABLE="mitgcmuv_ad"      EXECUTABLE="mitgcmuv_ad"
     OUTPUTFILE="output_adm.txt"  
901  else  else
902        code_dir=code
903        inputdir=input
904        ref_outp="output.txt"
905      EXECUTABLE="mitgcmuv"      EXECUTABLE="mitgcmuv"
     OUTPUTFILE="output.txt"  
906  fi  fi
907    
908  if test "x$ADM" = xt -a "x$COMMAND" = x ; then  if test "x$TESTDIRS" = x ; then
909      COMMAND="./$EXECUTABLE > $OUTPUTFILE"      LIST=`scandirs results/$ref_outp`
910    else
911        #- expand group of experiments:
912        LIST=" "
913        for xx in $TESTDIRS
914        do
915          case $xx in
916            'basic') LIST=${LIST}" aim.5l_cs hs94.128x64x5 ideal_2D_oce"
917                     LIST=${LIST}" lab_sea tutorial_baroclinic_gyre"
918                     LIST=${LIST}" tutorial_global_oce_latlon tutorial_plume_on_slope"
919                    ;;
920            'tutorials')
921                     LIST=${LIST}" "`ls | grep 'tutorial_'` ;;
922            *)       LIST=${LIST}" "$xx ;;
923          esac
924        done
925    fi
926    #echo 'LIST='${LIST}'<'
927    #- skip dirs, remove duplicate and non-directory:
928    TESTDIRS=" "
929    count=0
930    for xx in $LIST
931    do
932        yy=`echo $SKIPDIRS | grep -c $xx`
933        if test $yy = 0 ; then
934            if test -d $xx ; then
935                yy=`echo $TESTDIRS | grep -c $xx`
936                if test $yy = 0 ; then TESTDIRS=${TESTDIRS}" "$xx ; fi
937            else count=1 ;
938                echo ""; echo -n " -- skip \"$xx\" (not a directory !)"
939            fi
940        else
941            if test $count = 1 ; then echo -n ", \"$xx\""
942            else count=1 ; echo "" ;  echo -n " skip: \"$xx\""
943            fi
944        fi
945    done
946    if test $count = 1 ; then echo "" ; echo -n " ... " ; fi
947    #echo 'TESTDIRS='${TESTDIRS}'<'
948    
949    if test "x$OPTFILE" = xNONE -a "x$MITGCM_OF" != x ; then
950        OPTFILE=$MITGCM_OF
951  fi  fi
952    
953    OUTPUTFILE=$ref_outp
954  if test "x$COMMAND" = x ; then  if test "x$COMMAND" = x ; then
955      COMMAND="./$EXECUTABLE > $OUTPUTFILE"      COMMAND="./$EXECUTABLE > $OUTPUTFILE"
956  fi  fi
957    if test "x$MPI" = xt ; then
958        OUTPUTFILE="STDOUT.0000"
959    fi
960    
 #echo "OK"  
961  echo "OK (COMMAND= $COMMAND )"  echo "OK (COMMAND= $COMMAND )"
962    
963    # set the Default List of output variables to be checked:
964    #  (use default or load experiment-specific list from file "tr_checklist")
965    # content : 1rst = main variable used to decide if it pass or FAIL
966    #         others = number of matching digits to be printed in summary.txt
967    if test "x$ADM" = x ; then
968        DEF_CHECK_LIST='PS PS T+ S+ U+ V+ pt1+ pt2+ pt3+ pt4+ pt5+'
969        EMPTY_RESULTS='.. .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. ..'
970        LEN_CHECK_LIST=`echo $DEF_CHECK_LIST | sed 's/ [a-zA-Z0-9]*+/&mn &mx &av &sd/g' | awk '{print NF-1}'`
971        ii=`echo $EMPTY_RESULTS | awk '{print NF}'`
972        EMPTY_RESULTS=$EMPTY_RESULTS`expr $LEN_CHECK_LIST - $ii | awk 'BEGIN{FS=":"}{for(i=1;i<=$1;i++){printf "  ."}}'`
973    else
974        DEF_CHECK_LIST='Grad Cost Grad'
975        EMPTY_RESULTS='.. ..'
976        LEN_CHECK_LIST=`echo $DEF_CHECK_LIST | sed 's/ [a-zA-Z0-9]*+/&mn &mx &av &sd/g' | awk '{print NF-1}'`
977    fi
978    
979  #  create the FORTRAN comparison code  #  create the FORTRAN comparison code
980  createcodelet  createcodelet
981    
982  #  build the mpack utility  #  build the mpack utility (if ADDRESSES = NONE, do it to test the build)
983  if test "x$ADDRESSES" = xNONE -o "x$ADDRESSES" = x ; then  if test "x$ADDRESSES" = x ; then
984      echo "skipping mpack build"      echo "skipping mpack build"
985  else  else
986      build_mpack      build_mpack
987  fi  fi
988    
989  #  Create a uniquely named directory to store results  #  Create a uniquely named directory to store results
990    CMDLINE=$0
991    for xx in "$@" ; do CMDLINE="$CMDLINE '$xx'" ; done
992  MACH=`hostname`  MACH=`hostname`
993  UNAMEA=`uname -a`  UNAMEA=`uname -a`
994  DATE=`date +%Y%m%d`  DATE=`date +%Y%m%d`
# Line 896  if test "x$RETVAL" != x0 ; then Line 1009  if test "x$RETVAL" != x0 ; then
1009      exit 1      exit 1
1010  fi  fi
1011  SUMMARY="$DRESULTS/summary.txt"  SUMMARY="$DRESULTS/summary.txt"
 printf "Start time:  " >> $SUMMARY  
1012  start_date=`date`  start_date=`date`
1013  echo $start_date > $SUMMARY  echo $start_date > $SUMMARY
1014    echo 'run:' $CMDLINE >> $SUMMARY
1015    echo 'on :' $UNAMEA  >> $SUMMARY
1016    
1017  of_path=  of_path=
1018  if test "x$OPTFILE" != xNONE ; then  if test "x$OPTFILE" != xNONE ; then
# Line 928  fi Line 1042  fi
1042  echo  echo
1043  echo >> $SUMMARY  echo >> $SUMMARY
1044  if test "x$ADM" = x ; then  if test "x$ADM" = x ; then
1045      line_0="            ----T-----  ----S-----  ----U-----  ----V-----"      if [ $MATCH_CRIT -lt 10 ] ;
1046        then line_0="default  "$MATCH_CRIT ;
1047        else line_0="default "$MATCH_CRIT ; fi
1048           line_0="$line_0  ----T-----  ----S-----  ----U-----  ----V-----"
1049    #   line_0="            ----T-----  ----S-----  ----U-----  ----V-----"
1050      line_1="G D M    c        m  s        m  s        m  s        m  s"      line_1="G D M    c        m  s        m  s        m  s        m  s"
1051      line_2="E p a R  g  m  m  e  .  m  m  e  .  m  m  e  .  m  m  e  ."      line_2="E p a R  g  m  m  e  .  m  m  e  .  m  m  e  .  m  m  e  ."
1052      line_3="N n k u  2  i  a  a  d  i  a  a  d  i  a  a  d  i  a  a  d"      line_3="N n k u  2  i  a  a  d  i  a  a  d  i  a  a  d  i  a  a  d"
1053      line_4="2 d e n  d  n  x  n  .  n  x  n  .  n  x  n  .  n  x  n  ."      line_4="2 d e n  d  n  x  n  .  n  x  n  .  n  x  n  .  n  x  n  ."
1054      for ii in $PTRACERS_NUM ; do      for ii in $PTRACERS_NUM ; do
         #  tst=`eval 'echo $HAVE_PTR0'$ii`  
         #  if test "x$tst" = xt ; then  
1055          line_0="$line_0  --PTR 0"$ii"--"          line_0="$line_0  --PTR 0"$ii"--"
1056          line_1="$line_1        m  s"          line_1="$line_1        m  s"
1057          line_2="$line_2  m  m  e  ."          line_2="$line_2  m  m  e  ."
1058          line_3="$line_3  i  a  a  d"          line_3="$line_3  i  a  a  d"
1059          line_4="$line_4  n  x  n  ."          line_4="$line_4  n  x  n  ."
         #  fi  
1060      done      done
1061      echo "$line_0" | tee -a $SUMMARY      echo "$line_0" | tee -a $SUMMARY
1062      echo "$line_1" | tee -a $SUMMARY      echo "$line_1" | tee -a $SUMMARY
# Line 952  if test "x$ADM" = x ; then Line 1067  if test "x$ADM" = x ; then
1067  else  else
1068      echo "ADJOINT=true" >> $SUMMARY      echo "ADJOINT=true" >> $SUMMARY
1069      echo >> $SUMMARY      echo >> $SUMMARY
1070        if [ $MATCH_CRIT -lt 10 ] ;
1071        then line_0="default     "$MATCH_CRIT ;
1072        else line_0="default    "$MATCH_CRIT ; fi
1073        echo "$line_0" | tee -a $SUMMARY
1074      cat << EOF | tee -a $SUMMARY      cat << EOF | tee -a $SUMMARY
1075  G D M    C  G  G D M    C  G
1076  E p a R  o  r  E p a R  o  r
# Line 964  fi Line 1083  fi
1083  #  ...and each test directory...  #  ...and each test directory...
1084  for dir in $TESTDIRS ; do  for dir in $TESTDIRS ; do
1085            
1086        # set builddir & rundir:
1087        builddir="build"
1088        if test ! -d $dir/$builddir ; then mkdir $dir/$builddir ; fi
1089        rundir="run"
1090        if test ! -d $dir/$rundir ; then
1091            rundir=$builddir
1092        fi
1093        CODE_DIR=$dir/$code_dir
1094        BUILD_DIR=$dir/$builddir
1095    
1096      #  Cleanup only!      #  Cleanup only!
1097      if test "x$CLEANUP" = xt ; then      if test "x$CLEANUP" = xt ; then
1098          if test -r $dir/build/Makefile ; then          if test -r $BUILD_DIR/Makefile ; then
1099              echo '  ------  clean dir:' $dir/build              echo '  ------  clean dir:' $dir/$builddir
1100              ( cd $dir/build ; make CLEAN )              ( cd $BUILD_DIR ; make CLEAN )
1101          fi          fi
1102          if test -d $dir/run/CVS ; then          if test -d $dir/$rundir/CVS ; then
1103              echo '  ------  clean dir:' $dir/run              echo '  ------  clean dir:' $dir/$rundir
1104              run_clean $dir/run              run_clean $dir/$rundir
1105          fi          fi
1106          (          (
1107              cd $dir              cd $dir
# Line 983  for dir in $TESTDIRS ; do Line 1112  for dir in $TESTDIRS ; do
1112    
1113      #  Verify that the testdir exists and contains previous      #  Verify that the testdir exists and contains previous
1114      #  results in the correct location--or skip this directory!      #  results in the correct location--or skip this directory!
1115      fout=      fout=$dir"/results/"$ref_outp
     if test "x$ADM" = x ; then  
         fout=$dir"/results/output.txt"  
     else  
         fout=$dir"/results_ad/output_adm.txt"  
     fi  
1116      if test ! -r $fout ; then      if test ! -r $fout ; then
1117          echo "can't read \"$fout\" -- skipping $dir"          echo "can't read \"$fout\" -- skipping $dir"
1118          continue          continue
1119      fi      fi
     if test "x$ADM" = x ; then  
         check_for_add_mon_output  $fout  
     fi  
   
     # Check for additional types of monitor output  
1120    
1121      builddir="build"      # Check for specific files for particular type of run
     if test ! -d $dir/$builddir ; then mkdir $dir/$builddir ; fi  
     rundir="run"  
    #rundir=$builddir  
     if test ! -d $dir/$rundir ; then  
         rundir=$builddir  
     fi  
       
     if test "x$ADM" = x ; then  
         code_dir=code  
         CODE_DIR=$dir/code  
         input_dirs='input'  
     else  
         code_dir=code_ad  
         CODE_DIR=$dir/code_ad  
         input_dirs='input_ad input'  
     fi  
     BUILD_DIR=$dir/$builddir  
1122    
1123      if test ! -r $CODE_DIR"/SIZE.h_mpi" -a "x$MPI" = "xt" ; then      if test ! -r $CODE_DIR"/SIZE.h_mpi" -a "x$MPI" = "xt" ; then
1124          echo "can't find \"$CODE_DIR/SIZE.h_mpi\" -- skipping $dir"          echo "can't find \"$CODE_DIR/SIZE.h_mpi\" -- skipping $dir"
# Line 1029  for dir in $TESTDIRS ; do Line 1131  for dir in $TESTDIRS ; do
1131    
1132      #  Check whether there are "extra runs" for this testdir      #  Check whether there are "extra runs" for this testdir
1133      extra_runs=      extra_runs=
1134      if test "x$ADM" = x ; then      ex_run_dirs=`( cd $dir ; echo $inputdir.* )`
1135          ex_run_dirs=`( cd $dir ; echo input.* )`      #echo "ex_run_dirs='$ex_run_dirs'"
1136          #echo "ex_run_dirs='$ex_run_dirs'"      for exd in $ex_run_dirs ; do
1137          for exd in $ex_run_dirs ; do          name=`echo $exd | sed -e "s/$inputdir\.//"`
1138              name=`echo $exd | sed -e 's/input.//g'`          refExOut=`echo $ref_outp | sed "s/\./.${name}./"`
1139              outf="$dir/results/output.txt.$name"          outf="$dir/results/$refExOut"
1140              if test -f $outf -a -r $outf ; then          if test -f $outf -a -r $outf ; then
1141                  if test "x$MULTI_THREAD" = "xt" ; then              if test "x$MULTI_THREAD" = "xt" ; then
1142                      if test -r $dir"/"$exd"/eedata.mth" ; then                  if test -r $dir"/"$exd"/eedata.mth" ; then
                         extra_runs="$extra_runs $name"  
                     #else echo $dir"/"$exd"/eedata.mth: not found"  
                     fi  
                 else  
1143                      extra_runs="$extra_runs $name"                      extra_runs="$extra_runs $name"
1144                    #else echo $dir"/"$exd"/eedata.mth: not found"
1145                  fi                  fi
1146                else
1147                    extra_runs="$extra_runs $name"
1148              fi              fi
1149          done          fi
1150      fi      done
1151    
1152      echo "-------------------------------------------------------------------------------"      echo "-------------------------------------------------------------------------------"
1153      echo      echo
# Line 1057  for dir in $TESTDIRS ; do Line 1158  for dir in $TESTDIRS ; do
1158      fi      fi
1159      echo      echo
1160      unset genmake makedepend make run      unset genmake makedepend make run
1161      results='-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --'      results=$EMPTY_RESULTS
1162    
1163      #  Create an output dir for each OPTFILE/tdir combination      #  Create an output dir for each OPTFILE/tdir combination
1164      rel_CDIR=$DRESULTS"/"$dir      rel_CDIR=$DRESULTS"/"$dir
# Line 1075  for dir in $TESTDIRS ; do Line 1176  for dir in $TESTDIRS ; do
1176              && symlink_mpifiles $dir $code_dir $builddir \              && symlink_mpifiles $dir $code_dir $builddir \
1177              && makedependmodel $dir/$builddir && makedepend=Y \              && makedependmodel $dir/$builddir && makedepend=Y \
1178              && makemodel $dir/$builddir && make=Y \              && makemodel $dir/$builddir && make=Y \
1179              && linkdata $dir/$rundir $input_dirs \              && linkdata $dir/$rundir $inputdir input \
1180              && runmodel $dir/$rundir && run=Y \              && runmodel $dir/$rundir && run=Y \
1181              && results=`testoutput $dir $rundir`              && results=`testoutput_run $dir $rundir $ref_outp`
1182      fi      fi
1183            
1184      echo      echo
     if test "x$ADM" = x ; then  
1185          fres=`formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N} $results`          fres=`formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N} $results`
1186          echo          echo
1187          echo "$fres" >> $SUMMARY          echo "$fres" | sed 's/ 99/ --/g' | sed 's/  > />/' | sed 's/  < /</' >> $SUMMARY
1188          echo "fresults='$fres'" > $CDIR"/summary.txt"          touch $CDIR"/summary.txt"
1189            echo "fresults='$fres'" | sed 's/ 99/ --/g' >> $CDIR"/summary.txt"
1190          echo "MACH='$MACH'" >> $CDIR"/summary.txt"          echo "MACH='$MACH'" >> $CDIR"/summary.txt"
1191          echo "UNAMEA='$UNAMEA'" >> $CDIR"/summary.txt"          echo "UNAMEA='$UNAMEA'" >> $CDIR"/summary.txt"
1192          echo "DATE='$DATE'" >> $CDIR"/summary.txt"          echo "DATE='$DATE'" >> $CDIR"/summary.txt"
1193          echo "tdir='$dir'" >> $CDIR"/summary.txt"          echo "tdir='$dir'" >> $CDIR"/summary.txt"
1194            if test "x$ADM" = xt ; then
1195                head -1 $dir/$builddir/taf_ad.log >> $CDIR"/summary.txt"
1196                grep -A3 'Seconds in section "ALL' $dir/$rundir/$OUTPUTFILE \
1197                                    >> $CDIR"/summary.txt"
1198            fi
1199    
1200          for ex in $extra_runs ; do          for ex in $extra_runs ; do
1201              unset run              unset run
1202              results='-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --'              results=$EMPTY_RESULTS
1203                #  reference output file
1204                refExOut=`echo $ref_outp | sed "s/\./.${ex}./g"`
1205              #  Create an output dir for each OPTFILE/tdir.ex combination              #  Create an output dir for each OPTFILE/tdir.ex combination
1206              rel_CDIR=$DRESULTS"/"$dir"."$ex              rel_CDIR=$DRESULTS"/"$dir"."$ex
1207              mkdir $rel_CDIR              mkdir $rel_CDIR
1208              CDIR=`pwd`"/$rel_CDIR"              CDIR=`pwd`"/$rel_CDIR"
1209              test ! -e "$dir/tr_run.$ex" && mkdir "$dir/tr_run.$ex"              test ! -e "$dir/tr_run.$ex" && mkdir "$dir/tr_run.$ex"
1210              run_clean $dir/tr_run.$ex              run_clean $dir/tr_run.$ex
1211              linkdata $dir/tr_run.$ex input.$ex input              linkdata $dir/tr_run.$ex $inputdir.$ex $inputdir input
1212              runmodel $dir/tr_run.$ex && run=Y \              runmodel $dir/tr_run.$ex && run=Y \
1213                  && results=`testoutput $dir tr_run.$ex "."$ex`              && results=`testoutput_run $dir tr_run.$ex $refExOut`
             fres=`printf '%s %s %s %s' ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N}`  
1214              fres=`formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N} $results`              fres=`formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N} $results`
1215              fres="$fres.$ex"              fres="$fres.$ex"
1216              echo              echo
1217              echo "$fres" >> $SUMMARY              echo "$fres" | sed 's/ 99/ --/g' | sed 's/  > />/' | sed 's/  < /</' >> $SUMMARY
1218              echo "fresults='$fres'" > $CDIR"/summary.txt"              touch $CDIR"/summary.txt"
1219                echo "fresults='$fres'" | sed 's/ 99/ --/g' >> $CDIR"/summary.txt"
1220              echo "MACH='$MACH'" >> $CDIR"/summary.txt"              echo "MACH='$MACH'" >> $CDIR"/summary.txt"
1221              echo "UNAMEA='$UNAMEA'" >> $CDIR"/summary.txt"              echo "UNAMEA='$UNAMEA'" >> $CDIR"/summary.txt"
1222              echo "DATE='$DATE'" >> $CDIR"/summary.txt"              echo "DATE='$DATE'" >> $CDIR"/summary.txt"
1223              echo "tdir='$dir.$ex'" >> $CDIR"/summary.txt"              echo "tdir='$dir.$ex'" >> $CDIR"/summary.txt"
1224                if test "x$ADM" = xt ; then
1225                    head -1 $dir/$builddir/taf_ad.log >> $CDIR"/summary.txt"
1226                    grep -A3 'Seconds in section "ALL' $dir/tr_run.$ex/$OUTPUTFILE \
1227                                       >> $CDIR"/summary.txt"
1228                fi
1229              if test "x$POSTCLEAN" = xt ; then              if test "x$POSTCLEAN" = xt ; then
1230                  run_clean $dir/tr_run.$ex                  run_clean $dir/tr_run.$ex
1231              fi              fi
1232          done          done
     else  
         fres=`printf '%s %s %s %s' ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N}`  
         fres=$fres"$results   $dir"  
         echo  
         echo "$fres" >> $SUMMARY  
         echo "fresults='$fres'" > $CDIR"/summary.txt"  
         echo "MACH='$MACH'" >> $CDIR"/summary.txt"  
         echo "UNAMEA='$UNAMEA'" >> $CDIR"/summary.txt"  
         echo "DATE='$DATE'" >> $CDIR"/summary.txt"  
         echo "tdir='$dir'" >> $CDIR"/summary.txt"  
         grep -A3 'Seconds in section "ALL' $dir/$rundir/$OUTPUTFILE \  
                            >> $CDIR"/summary.txt"  
     fi  
1233    
1234      #postclean $dir/$builddir      #postclean $dir/$builddir
1235      if test "x$POSTCLEAN" = xt ; then      if test "x$POSTCLEAN" = xt ; then
# Line 1142  for dir in $TESTDIRS ; do Line 1242  for dir in $TESTDIRS ; do
1242  done  done
1243    
1244  printf "Start time:  " >> $SUMMARY  printf "Start time:  " >> $SUMMARY
1245  echo $start_date >> $SUMMARY  echo "$start_date" >> $SUMMARY
1246  printf "End time:    " >> $SUMMARY  printf "End time:    " >> $SUMMARY
1247  date >> $SUMMARY  date >> $SUMMARY
1248    
# Line 1173  else Line 1273  else
1273      fi      fi
1274  fi  fi
1275    
1276  # rm -f tmp_cmpnum.f a.out  rm -f tr_cmpnum.c tr_cmpnum
 rm -f tmp_cmpnum.c tmp_cmpnum  
1277    
1278  if test "x$CLEANUP" != xt ; then  if test "x$CLEANUP" != xt ; then
1279      cat $SUMMARY | sed 's/ -- -- -- --//g'      cat $SUMMARY | sed 's/ \.  \.  \.  \.  \.  \.  \.  \.  \.  \.  \.  \. //'
1280      if test -e tr_out.txt ; then      if test -e tr_out.txt ; then
1281          mv tr_out.txt tr_out.txt.old          mv tr_out.txt tr_out.txt.old
1282      fi      fi
1283      cat $SUMMARY | sed 's/ -- -- -- --//g' > tr_out.txt      cat $SUMMARY | sed '/^[YN] [YN] [YN] [YN]/ s/ \. //g' > tr_out.txt
1284  fi  fi
1285    
1286  if test "x$DELDIR" = xt ; then  if test "x$DELDIR" = xt ; then

Legend:
Removed from v.1.83  
changed lines
  Added in v.1.117

  ViewVC Help
Powered by ViewVC 1.1.22